
option expr32
option casemap:none

; Begin of file hcf.h
;  This file is part of the Hardware Control Functions Light (HCF-light) library
;    to control the Lucent Technologies WaveLAN/IEEE Network I/F Card.
;    The HCF is the implementation of the Wireless Connection I/F (WCI).
;    
;    The HCF-light files are a subset of the HCF files. The complete set offers a
;    number of additional facilities, e.g. firmware download, Etherner-II encapsulation,
;    additional diagnostic facilities, ASSERT logic to support debugging, 802.11 support,
;    Configuration Management.
;    This complete set is explicitely not in the Public Domain but can be made 
;    available under certain restriction. (see the pointer below for support)
;    
;    The HCF-light files are free software; you can redistribute it and/or modify it
;    under the terms of the GNU General Public License as published by the
;    Free Software Foundation; either version 2 of the License, or (at your
;    option) any later version.
; 
;    This program is distributed in the hope that it will be useful, but
;    WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;    General Public License for more details.
; 
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software Foundation,
;    Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
;    
;    At the time of this writing, you can request for support at:
;    betasupport@wavelan.com
;    
;    Documentation is expected to be available in the week of 8 Februari 1999
; 
; 
HCF_H		EQU		1t
; ************************************************************************************************************
; *
; * FILE	 : hcf.h *************** 2.0 *************************************************************************
; *
; * DATE   : $Date:   02 Feb 1999 14:32:36  $   $Revision:   1.0  $
; *
; * AUTHOR : Nico Valster
; *
; * DESC   : Definitions and Prototypes for MSF as well as HCF sources
; *
; *			Customizable via HCFCFG.H
; *
; *
; **************************************************************************************************************
; Instructions to convert HCF.H to HCF.INC by means of H2INC
; 
; Use a command line which defines the specific macros and command line options
; needed to build the C-part, e.g. for the DOS ODI driver
; 		`h2inc /C /Ni /Zp /Zn hcf	 hcf.h`
; 
; 
; **************************************************************************************************************
; * COPYRIGHT (c) 1996, 1997, 1998 by Lucent Technologies.	 All Rights Reserved.
; *************************************************************************************************************
; ***************************************************************************
; $Log:   V:/dev3dev/hcfl/code/hcf.inv  $
 ; 
 ;    Rev 1.0   02 Feb 1999 14:32:36   NVALST
 ; Initial revision.
; Revision 1.2  1999/02/01 22:58:35  nico
; *** empty log message ***
; 
; Revision 1.1  1999/01/30 19:24:39  nico
; Initial revision
; 
; Revision 1.1  1999/01/30 19:07:57  nico
; Initial revision
; 
;  * 
;  *    Rev 1.110   29 Jan 1999 15:52:42   NVALST
;  * intermediate, maybe working but seems to need two times to load in 
;  * light-version
;  * 
;  *    Rev 2.12   29 Jan 1999 10:48:44   NVALST
;  * 
;  *    Rev 1.108   28 Jan 1999 14:43:22   NVALST
;  * 
; ***************************************************************************
; *************************************************************************************************************
; *
; * CHANGE HISTORY
; *
;   961018 - NV
; 	Original Entry
; 
; ************************************************************************************************************
;  System Constants to be defined by the MSF-programmer to tailor the HCF
; Begin of file hcfcfg.h
;  This file is part of the Hardware Control Functions Light (HCF-light) library
;    to control the Lucent Technologies WaveLAN/IEEE Network I/F Card.
;    The HCF is the implementation of the Wireless Connection I/F (WCI).
;    
;    The HCF-light files are a subset of the HCF files. The complete set offers a
;    number of additional facilities, e.g. firmware download, Etherner-II encapsulation,
;    additional diagnostic facilities, ASSERT logic to support debugging, 802.11 support,
;    Configuration Management.
;    This complete set is explicitely not in the Public Domain but can be made 
;    available under certain restriction. (see the pointer below for support)
;    
;    The HCF-light files are free software; you can redistribute it and/or modify it
;    under the terms of the GNU General Public License as published by the
;    Free Software Foundation; either version 2 of the License, or (at your
;    option) any later version.
; 
;    This program is distributed in the hope that it will be useful, but
;    WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;    General Public License for more details.
; 
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software Foundation,
;    Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
;    
;    At the time of this writing, you can request for support at:
;    betasupport@wavelan.com
;    
;    Documentation is expected to be available in the week of 8 Februari 1999
; 
; 
HCFCFG_H		EQU		1t
; *************************************************************************************************************
; *
; * FILE	 : hcfcfg.tpl // hcfcfg.h **************************** 2.0 ********************************************
; *
; * DATE   : $Date:   02 Feb 1999 14:32:36  $   $Revision:   1.0  $
; *
; * AUTHOR : Nico Valster
; *
; * DESC   : HCF Customization Macros
; *
; ***************************************************************************************************************
; * COPYRIGHT (c) 1994, 1995		 by AT&T.	 				All Rights Reserved.
; * COPYRIGHT (c) 1996, 1997, 1998 by Lucent Technologies.	All Rights Reserved.
; *
; ***************************************************************************************************************
; *
; * hcfcfg.tpl list all #defines which must be specified to:
; *    I:	adjust the HCF functions defined in HCF.CPP to the characteristics of a specific environment
; * 		o maximum sizes for messages and notification frames, persistent configuration storage
; * 		o Endianess
; *
; *	II:	Compiler specific macros
; * 		o port I/O macros
; * 		o type definitions
; *
; *  III:	Environment specific ASSERT macro
; *
; *   IV: Compiler specific 
; *
; *    V: ;? specific 
; *
; *
; * By copying HCFCFG.TPL to HCFCFG.H and -if needed- modifying the #defines the WCI functionality can be 
; * tailored
; * T O   D O :  A D D   A   R E C I P E   T O   D O   T H I S
; *
; *************************************************************************************************************
; ***************************************************************************
; $Log$
; Revision 1.2  1999/02/01 21:01:41  nico
; *** empty log message ***
; 
; Revision 1.1  1999/01/30 19:24:39  nico
; Initial revision
; 
; Revision 1.1  1999/01/30 19:07:57  nico
; Initial revision
; 
;  * 
;  *    Rev 1.110   29 Jan 1999 15:52:44   NVALST
;  * intermediate, maybe working but seems to need two times to load in 
;  * light-version
;  * 
;  *    Rev 1.109   29 Jan 1999 12:50:26   NVALST
;  * intermediate
;  * 
;  *    Rev 1.108   28 Jan 1999 14:43:24   NVALST
;  * intermediate, once more correction of loop in hcf_service_nic + download
;  * passed to Marc
;  * 
;  *    Rev 1.107   27 Jan 1999 13:53:24   NVALST
;  * intermediate, once more correction of loop in hcf_service_nic
;  * 
;  *    Rev 1.106   26 Jan 1999 16:42:46   NVALST
;  * intermediate, corrected loop in hcf_service_nic (which was as result of a 
;  * walkthrough, changed from a bug without consequences into one with consequences
;  * 
;  *    Rev 1.105   25 Jan 1999 14:24:48   NVALST
;  * intermediate, hopefully suitable for release
;  * 
;  *    Rev 1.104   22 Jan 1999 16:59:34   NVALST
;  * intermediate, minor corrections + some HCF-L stuff
;  * 
;  *    Rev 1.103   15 Jan 1999 15:14:46   NVALST
;  * intermediate, deposited as HCF2.10
;  * 
; ************************************************************************************************
; ***************************************************************************
; *
; * CHANGE HISTORY
; *
; 
;   960702 - NV
; 	Original Entry - derived from HCF 2.12
; ************************************************************************************************
;   * * * * * * * * * * * * * * * * * * * * * *  I * * * * * * * * * * * * * * * * * * * * * * 
; 	Endianess
;  *	Default: HCF_LITTLE_ENDIAN
;  *	Little Endian (a.k.a. Intel), least significant byte first
;  *	Big Endian (a.k.a. Motorola), most significant byte first
;  *
;  * If neither HCF_LITTLE_ENDIAN nor HCF_BIG_ENDIAN, the defintion of the following macros must be supplied
;  * by the MSF programmer:
;  *  o CNV_LITTLE_TO_INT(w)			interprets the 16-bits input value as Little Endian, returns an hcf_16
;  * 	o CNV_BIG_TO_INT(w)				interprets the 16-bits input value as Big Endian, returns an hcf_16
;  * 	o CNV_INT_TO_BIG_NP(addr)		converts in place the 16-bit value addressed by a near pointer from hcf_16
;  * 									to Big Endian
;  * 	o CNV_LITTLE_TO_INT_NP(addr)	converts in place the 16-bit value addressed by a near pointer from 
;  *									Little endian to hcf_16
;  *
;  * At a number of places in the HCF code, the CNV_INT_TO_BIG_NP macro is used. While it does have the desired 
;  * effect on all platforms, it's naming is misleading, so revisit all places where these CNV macros are used
;  * to assure the right name is used at the right place.
;  * Hint: introduce CNV_HOST_TO_NETWORK names if appropriate
;  *
;  
;  selects Little Endian (a.k.a. Intel), least significant byte first
; #define HCF_BIG_ENDIAN				// selects Big Endian (a.k.a. Motorola), most significant byte first
; 	I/O Address size
;  *	Platforms which use port mapped I/O will (in general) have a 64k I/O space, conveniently expressed in
;  *	a 16-bits quantity
;  *	Platforms which use memory mapped I/O will (in general) have an I/O space much larger than 64k,
;  *	and need a 32-bits quantity to express the I/O base
;  *	To accomodate this the macros HCF_PORT_IO and HCF_MEM_IO are available. Exactly 1 of these must be
;  *	defined. If HCF_PORT_IO is defined, the HCF will use an hcf_16 to express I/O base and store in the
;  *	IFB. If HCF_MEM_IO, an hcf_32 is used for this purpose. The default is HCF_PORT_IO
;  
; #define HCF_MEM_IO
; 	Alignment
;  *	Some platforms can access words on odd boundaries (with possibly an performance impact), at other
;  *	platforms such an access may result in a memory access violation.
;  *	It is assumed that everywhere where the HCF casts a char pointer into a word pointer, the 
;  *	alignment criteria are met. This put some restrictions on the MSF, which are assumed to be 
;  *	"automatically" fullfilled at the applicable platforms
;  *	To assert this assumption, the macro HCF_ALIGN can be defined. The default vaslue is 0, meaning no
;  *	alignment, a value of 2 means word alignment, other values are invalid
;  
;   * * * * * * * * * * * * * * * * * * * * * * II * * * * * * * * * * * * * * * * * * * * * * 
; **********************************************************************************************
; *****************  C O M P I L E R   S P E C I F I C   M A C R O S  **************************
; **********************************************************************************************
; ************************************************************************************************
; *
; * The platforms supported by this version are:
; *	- Microsoft Visual C 1.5 (16 bits platform)
; *	- Microsoft Visual C 2.0 (32 bits platform)
; *	- Watcom C/C++ 9.5
; *	- SCO UNIX
; *
; * In this version of hcfiocfg.tpl all macros except the MSVC 1.5 versions are either dependent on
; * compiler/environment supplied macros (e.g. _MSC_VER or "def-ed out"
; *
; * By selecting the appropriate Macro definitions by means of modifying the
; * "#ifdef 0/1" lines, the HCF can be adjusted for the I/O chararcteristics of
; * a specific compiler
; *
; * If needed the macros can be modified or replaced with definitions appropriate
; * for your personal platform
; * If you need to make such changes it is appreciated if you inform Lucent Technologies WCND Utrecht
; * That way the changes can become part of the next release of the WCI
; *
; *
; *	The prototypes and functional description of the macros are:
; *
; *	hcf_8	IN_PORT_BYTE(  hcf_16 port)
; *			Reads a byte (8 bits) from the specified port
; *
; *	hcf_16	IN_PORT_WORD(  hcf_16 port)
; *			Reads a word (16 bits) from the specified port
; *
; *	void	OUT_PORT_BYTE( hcf_16 port, hcf_8 value)
; *			Writes a byte (8 bits) to the specified port
; *
; *	void	OUT_PORT_WORD( hcf_16 port, hcf_16 value)
; *			Writes a word (16 bits) to the specified port
; *
; *	void	IN_PORT_STRING( port, dest, len)
; *			Reads len number of words from the specified port to the (FAR) address dest in PC-RAM
; *			Note that len specifies the number of words, NOT the number of bytes
; *			!!!NOTE, although len specifies the number of words, dest MUST be a char pointer NOTE!!!
; *			See also the common notes for IN_PORT_STRING and OUT_PORT_STRING
; *
; *	void	OUT_PORT_STRING( port, src, len)
; *			Writes len number of words from the (FAR) address src in PC-RAM to the specified port
; *			Note that len specifies the number of words, NOT the number of bytes.
; *			!!!NOTE, although len specifies the number of words, src MUST be a char pointer NOTE!!!
; *
; *			The peculiar combination of word-length and char pointers for IN_PORT_STRING as well as
; *			OUT_PORT_STRING is justified by the assumption that it offers a more optimal algorithm
; *
; *			Note to the HCF-implementor:
; *			Due to the passing of the parameters to compiler specific blabla.........
; *			do not use "expressions" as parameters, e.g. don't use "ifbp->IFB_IOBase + HREG_AUX_DATA" but
; *			assign this to a temporary variable.
; *
; *
; *  NOTE!!	For convenience of the MSF-programmer, all {IN|OUT}_PORT_{BYTE|WORD|STRING} macros are allowed to 
; *			modify their parameters (although some might argue that this would constitute bad coding
; *			practice). This has its implications on the HCF, e.g. as a consequence these macros should not
; *			be called with parameters which have side effects, e.g auto-increment.
; *
; *  NOTE!!	in the Micosoft implementation of inline assembly it is O.K. to corrupt all flags except
; *			the direction flag and to corrupt all registers except the segment registers and EDI, ESI, 
; *			ESP and EBP (or their 16 bits equivalents).
; *			Other environments may have other constraints
; *
; *  NOTE!!	in the Intel environment it is O.K to have a word (as a 16 bits quantity) at a byte boundary, 
; *			hence IN_/OUT_PORT_STRING can move words between PC-memory and NIC-memory with as only
; *			constraint that the the words are on a word boundary in NIC-memory. This does not hold true
; *			for all conceivalble environments, e.g. an Motorola 68xxx does not allow this, in other
; *			words whenever there is a move from address in 2*n in one memory type to address 2*m+1 in the
; *			other type, the current templates for IN_/OUT_PORT_STRING are unsuitable. Probably the
; *			boundary conditions imposed by these type of platforms prevent this case from materializing
; *
; ************************************************************************************************
; **********************************************************************************************
; ***************************  N E T W A R E   3 8 6  ******************************************
; **********************************************************************************************
;  Note:
;  Visual C++ 1.5 : _MSC_VER ==  800
;  Visual C++ 4.0 : _MSC_VER == 1000
;  Visual C++ 4.2 : _MSC_VER == 1020
; **********************************************************************************************
; ***************************  P A C K E T   D R I V E R  **************************************
; *********************************  D O S   O D I  ********************************************
; **********************************************************************************************
; station characteristics
HCF_MAX_CONFIG		EQU		0t
MSF_COMPONENT_MAJOR_VER		EQU		0t
MSF_COMPONENT_MINOR_VER		EQU		1t
; WVLAN_xx
;  segmented 16 bits mode
;  _M_I86TM
hcf_8		TYPEDEF		BYTE

hcf_16		TYPEDEF		WORD

hcf_32		TYPEDEF		DWORD

; Begin of file c:\msvc\include\stdio.h
; **
; *stdio.h - definitions/declarations for standard I/O routines
; *
; *   Copyright (c) 1985-1992, Microsoft Corporation. All rights reserved.
; *
; *Purpose:
; *   This file defines the structures, values, macros, and functions
; *   used by the level 2 I/O ("standard I/O") routines.
; *   [ANSI/System V]
; *
; ***
size_t		TYPEDEF		WORD

va_list		TYPEDEF		PTR SBYTE

;  buffered I/O macros 
BUFSIZ		EQU		512t
_NFILE		EQU		20t
EOF		EQU		0ffffffffh
@t_hcf0		TYPEDEF		PTR SBYTE
@t_hcf1		TYPEDEF		PTR SBYTE
_iobuf		STRUCT 2t
_ptr		@t_hcf0		?
_cnt		SWORD		?
_base		@t_hcf1		?
_flag		SBYTE		?
_file		SBYTE		?
_iobuf		ENDS

FILE		TYPEDEF		_iobuf

;  _P_tmpnam: Directory where temporary files may be created.
;  * L_tmpnam size =  size of _P_tmpdir
;  *  + 1 (in case _P_tmpdir does not end in "")
;  *  + 6 (for the temp number string)
;  *  + 1 (for the null terminator)
;  
;  fseek constants 
SEEK_CUR		EQU		1t
SEEK_END		EQU		2t
SEEK_SET		EQU		0t
;  minimum guaranteed filename length, open file count, and unique
;  * tmpnam filenames.
;  
FILENAME_MAX		EQU		128t
FOPEN_MAX		EQU		18t
TMP_MAX		EQU		32767t
_SYS_OPEN		EQU		20t
;  define NULL pointer value 
;  declare _iob[] array 
EXTERNDEF		C _iob:FILE

;  define file position type 
fpos_t		TYPEDEF		SDWORD

;  standard file pointers 
_IOREAD		EQU		000000001h
_IOWRT		EQU		000000002h
_IOFBF		EQU		000000000h
_IOLBF		EQU		000000040h
_IONBF		EQU		000000004h
_IOMYBUF		EQU		000000008h
_IOEOF		EQU		000000010h
_IOERR		EQU		000000020h
_IOSTRG		EQU		000000040h
_IORW		EQU		000000080h
;  function prototypes 
@proto_hcf0		TYPEDEF		PROTO C :PTR FILE
_filbuf		PROTO		@proto_hcf0

@proto_hcf1		TYPEDEF		PROTO C :SWORD, :PTR FILE
_flsbuf		PROTO		@proto_hcf1

@proto_hcf2		TYPEDEF		PROTO C :PTR SBYTE, :PTR SBYTE, :SWORD
_fsopen		PROTO		@proto_hcf2

@proto_hcf3		TYPEDEF		PROTO C :PTR FILE
clearerr		PROTO		@proto_hcf3

@proto_hcf4		TYPEDEF		PROTO C :PTR FILE
fclose		PROTO		@proto_hcf4

@proto_hcf5		TYPEDEF		PROTO C 
_fcloseall		PROTO		@proto_hcf5

@proto_hcf6		TYPEDEF		PROTO C :SWORD, :PTR SBYTE
_fdopen		PROTO		@proto_hcf6

@proto_hcf7		TYPEDEF		PROTO C :PTR FILE
feof		PROTO		@proto_hcf7

@proto_hcf8		TYPEDEF		PROTO C :PTR FILE
ferror		PROTO		@proto_hcf8

@proto_hcf9		TYPEDEF		PROTO C :PTR FILE
fflush		PROTO		@proto_hcf9

@proto_hcf10		TYPEDEF		PROTO C :PTR FILE
fgetc		PROTO		@proto_hcf10

@proto_hcf11		TYPEDEF		PROTO C 
_fgetchar		PROTO		@proto_hcf11

@proto_hcf12		TYPEDEF		PROTO C :PTR FILE, :PTR fpos_t
fgetpos		PROTO		@proto_hcf12

@proto_hcf13		TYPEDEF		PROTO C :PTR SBYTE, :SWORD, :PTR FILE
fgets		PROTO		@proto_hcf13

@proto_hcf14		TYPEDEF		PROTO C :PTR FILE
_fileno		PROTO		@proto_hcf14

@proto_hcf15		TYPEDEF		PROTO C 
_flushall		PROTO		@proto_hcf15

@proto_hcf16		TYPEDEF		PROTO C :PTR SBYTE, :PTR SBYTE
fopen		PROTO		@proto_hcf16

@proto_hcf17		TYPEDEF		PROTO C :PTR FILE, :PTR SBYTE, :VARARG
fprintf		PROTO		@proto_hcf17

@proto_hcf18		TYPEDEF		PROTO C :SWORD, :PTR FILE
fputc		PROTO		@proto_hcf18

@proto_hcf19		TYPEDEF		PROTO C :SWORD
_fputchar		PROTO		@proto_hcf19

@proto_hcf20		TYPEDEF		PROTO C :PTR SBYTE, :PTR FILE
fputs		PROTO		@proto_hcf20

@proto_hcf21		TYPEDEF		PROTO C :PTR , :size_t, :size_t, :PTR FILE
fread		PROTO		@proto_hcf21

@proto_hcf22		TYPEDEF		PROTO C :PTR SBYTE, :PTR SBYTE, :PTR FILE
freopen		PROTO		@proto_hcf22

@proto_hcf23		TYPEDEF		PROTO C :PTR FILE, :PTR SBYTE, :VARARG
fscanf		PROTO		@proto_hcf23

@proto_hcf24		TYPEDEF		PROTO C :PTR FILE, :PTR SDWORD
fsetpos		PROTO		@proto_hcf24

@proto_hcf25		TYPEDEF		PROTO C :PTR FILE, :SDWORD, :SWORD
fseek		PROTO		@proto_hcf25

@proto_hcf26		TYPEDEF		PROTO C :PTR FILE
ftell		PROTO		@proto_hcf26

@proto_hcf27		TYPEDEF		PROTO C :PTR , :size_t, :size_t, :PTR FILE
fwrite		PROTO		@proto_hcf27

@proto_hcf28		TYPEDEF		PROTO C :PTR FILE
getc		PROTO		@proto_hcf28

@proto_hcf29		TYPEDEF		PROTO C 
getchar		PROTO		@proto_hcf29

@proto_hcf30		TYPEDEF		PROTO C :PTR SBYTE
gets		PROTO		@proto_hcf30

@proto_hcf31		TYPEDEF		PROTO C :PTR FILE
_getw		PROTO		@proto_hcf31

@proto_hcf32		TYPEDEF		PROTO C :PTR SBYTE
perror		PROTO		@proto_hcf32

@proto_hcf33		TYPEDEF		PROTO C :PTR SBYTE, :VARARG
printf		PROTO		@proto_hcf33

@proto_hcf34		TYPEDEF		PROTO C :SWORD, :PTR FILE
putc		PROTO		@proto_hcf34

@proto_hcf35		TYPEDEF		PROTO C :SWORD
putchar		PROTO		@proto_hcf35

@proto_hcf36		TYPEDEF		PROTO C :PTR SBYTE
puts		PROTO		@proto_hcf36

@proto_hcf37		TYPEDEF		PROTO C :SWORD, :PTR FILE
_putw		PROTO		@proto_hcf37

@proto_hcf38		TYPEDEF		PROTO C :PTR SBYTE
remove		PROTO		@proto_hcf38

@proto_hcf39		TYPEDEF		PROTO C :PTR SBYTE, :PTR SBYTE
rename		PROTO		@proto_hcf39

@proto_hcf40		TYPEDEF		PROTO C :PTR FILE
rewind		PROTO		@proto_hcf40

@proto_hcf41		TYPEDEF		PROTO C 
_rmtmp		PROTO		@proto_hcf41

@proto_hcf42		TYPEDEF		PROTO C :PTR SBYTE, :VARARG
scanf		PROTO		@proto_hcf42

@proto_hcf43		TYPEDEF		PROTO C :PTR FILE, :PTR SBYTE
setbuf		PROTO		@proto_hcf43

@proto_hcf44		TYPEDEF		PROTO C :PTR FILE, :PTR SBYTE, :SWORD, :size_t
setvbuf		PROTO		@proto_hcf44

@proto_hcf45		TYPEDEF		PROTO C :PTR SBYTE, :size_t, :PTR SBYTE, :VARARG
_snprintf		PROTO		@proto_hcf45

@proto_hcf46		TYPEDEF		PROTO C :PTR SBYTE, :PTR SBYTE, :VARARG
sprintf		PROTO		@proto_hcf46

@proto_hcf47		TYPEDEF		PROTO C :PTR SBYTE, :PTR SBYTE, :VARARG
sscanf		PROTO		@proto_hcf47

@proto_hcf48		TYPEDEF		PROTO C :PTR SBYTE, :PTR SBYTE
_tempnam		PROTO		@proto_hcf48

@proto_hcf49		TYPEDEF		PROTO C 
tmpfile		PROTO		@proto_hcf49

@proto_hcf50		TYPEDEF		PROTO C :PTR SBYTE
tmpnam		PROTO		@proto_hcf50

@proto_hcf51		TYPEDEF		PROTO C :SWORD, :PTR FILE
ungetc		PROTO		@proto_hcf51

@proto_hcf52		TYPEDEF		PROTO C :PTR SBYTE
_unlink		PROTO		@proto_hcf52

@proto_hcf53		TYPEDEF		PROTO C :PTR FILE, :PTR SBYTE, :va_list
vfprintf		PROTO		@proto_hcf53

@proto_hcf54		TYPEDEF		PROTO C :PTR SBYTE, :va_list
vprintf		PROTO		@proto_hcf54

@proto_hcf55		TYPEDEF		PROTO C :PTR SBYTE, :size_t, :PTR SBYTE, :va_list
_vsnprintf		PROTO		@proto_hcf55

@proto_hcf56		TYPEDEF		PROTO C :PTR SBYTE, :PTR SBYTE, :va_list
vsprintf		PROTO		@proto_hcf56

;  macro definitions 
;  Non-ANSI names for compatibility 
SYS_OPEN		EQU		000000014h
@proto_hcf57		TYPEDEF		PROTO C 
fcloseall		PROTO		@proto_hcf57

@proto_hcf58		TYPEDEF		PROTO C :SWORD, :PTR SBYTE
fdopen		PROTO		@proto_hcf58

@proto_hcf59		TYPEDEF		PROTO C 
fgetchar		PROTO		@proto_hcf59

@proto_hcf60		TYPEDEF		PROTO C :PTR FILE
fileno		PROTO		@proto_hcf60

@proto_hcf61		TYPEDEF		PROTO C 
flushall		PROTO		@proto_hcf61

@proto_hcf62		TYPEDEF		PROTO C :SWORD
fputchar		PROTO		@proto_hcf62

@proto_hcf63		TYPEDEF		PROTO C :PTR FILE
getw		PROTO		@proto_hcf63

@proto_hcf64		TYPEDEF		PROTO C :SWORD, :PTR FILE
putw		PROTO		@proto_hcf64

@proto_hcf65		TYPEDEF		PROTO C 
rmtmp		PROTO		@proto_hcf65

@proto_hcf66		TYPEDEF		PROTO C :PTR SBYTE, :PTR SBYTE
tempnam		PROTO		@proto_hcf66

@proto_hcf67		TYPEDEF		PROTO C :PTR SBYTE
unlink		PROTO		@proto_hcf67

; End of file c:\msvc\include\stdio.h
; Begin of file c:\msvc\include\conio.h
; **
; *conio.h - console and port I/O declarations
; *
; *   Copyright (c) 1985-1992, Microsoft Corporation.  All rights reserved.
; *
; *Purpose:
; *   This include file contains the function declarations for
; *   the MS C V2.03 compatible console and port I/O routines.
; *
; ***
;  function prototypes 
@proto_hcf68		TYPEDEF		PROTO C :PTR SBYTE
_cgets		PROTO		@proto_hcf68

@proto_hcf69		TYPEDEF		PROTO C :PTR SBYTE, :VARARG
_cprintf		PROTO		@proto_hcf69

@proto_hcf70		TYPEDEF		PROTO C :PTR SBYTE
_cputs		PROTO		@proto_hcf70

@proto_hcf71		TYPEDEF		PROTO C :PTR SBYTE, :VARARG
_cscanf		PROTO		@proto_hcf71

@proto_hcf72		TYPEDEF		PROTO C 
_getch		PROTO		@proto_hcf72

@proto_hcf73		TYPEDEF		PROTO C 
_getche		PROTO		@proto_hcf73

@proto_hcf74		TYPEDEF		PROTO C :WORD
_inp		PROTO		@proto_hcf74

@proto_hcf75		TYPEDEF		PROTO C :WORD
_inpw		PROTO		@proto_hcf75

@proto_hcf76		TYPEDEF		PROTO C 
_kbhit		PROTO		@proto_hcf76

@proto_hcf77		TYPEDEF		PROTO C :WORD, :SWORD
_outp		PROTO		@proto_hcf77

@proto_hcf78		TYPEDEF		PROTO C :WORD, :WORD
_outpw		PROTO		@proto_hcf78

@proto_hcf79		TYPEDEF		PROTO C :SWORD
_putch		PROTO		@proto_hcf79

@proto_hcf80		TYPEDEF		PROTO C :SWORD
_ungetch		PROTO		@proto_hcf80

;  Non-ANSI names for compatibility 
@proto_hcf81		TYPEDEF		PROTO C :PTR SBYTE
cgets		PROTO		@proto_hcf81

@proto_hcf82		TYPEDEF		PROTO C :PTR SBYTE, :VARARG
cprintf		PROTO		@proto_hcf82

@proto_hcf83		TYPEDEF		PROTO C :PTR SBYTE
cputs		PROTO		@proto_hcf83

@proto_hcf84		TYPEDEF		PROTO C :PTR SBYTE, :VARARG
cscanf		PROTO		@proto_hcf84

@proto_hcf85		TYPEDEF		PROTO C 
getch		PROTO		@proto_hcf85

@proto_hcf86		TYPEDEF		PROTO C 
getche		PROTO		@proto_hcf86

@proto_hcf87		TYPEDEF		PROTO C :WORD
inp		PROTO		@proto_hcf87

@proto_hcf88		TYPEDEF		PROTO C :WORD
inpw		PROTO		@proto_hcf88

@proto_hcf89		TYPEDEF		PROTO C 
kbhit		PROTO		@proto_hcf89

@proto_hcf90		TYPEDEF		PROTO C :WORD, :SWORD
outp		PROTO		@proto_hcf90

@proto_hcf91		TYPEDEF		PROTO C :WORD, :WORD
outpw		PROTO		@proto_hcf91

@proto_hcf92		TYPEDEF		PROTO C :SWORD
putch		PROTO		@proto_hcf92

@proto_hcf93		TYPEDEF		PROTO C :SWORD
ungetch		PROTO		@proto_hcf93

; End of file c:\msvc\include\conio.h
; #ifndef _DEBUG 
; #endif // _DEBUG
;  C implementation
;  Asm or C implementation
;  WVLAN_43, WVLAN_42 (DOS ODI, Packet Driver) 
; **********************************************************************************************
; ************************************  W C I T S T ********************************************
; **********************************************************************************************
; **********************************************************************************************
; *******************************************  W S U  ******************************************
; **********************************************************************************************
; ;? conflicts with WIN_CE _MSC_VER >= 1000 	/* Microsoft Visual C ++ 4.x, 5.x */
; **********************************************************************************************
; *****************************************  L I N U X  ****************************************
; **********************************************************************************************
; **********************************************************************************************
; ********************************* S C O   U N I X  *******************************************
; **********************************************************************************************
; **********************************************************************************************
; ********************************  M I N I P O R T  *******************************************
; **********************************************************************************************
; **********************************************************************************************
; ********************************  W A V E P O I N T  *****************************************
; **********************************************************************************************
; **********************************************************************************************
; *************************  MPC860 - Diab or High C 29K   *************************************
; **********************************************************************************************
; || (CPU == PPC860)
; **********************************************************************************************
; **********************************  M A C  O S   *********************************************
; **********************************************************************************************
; ********
; **********************************************************************************************
; **********************************  W I N C E ************************************************
; **********************************************************************************************
; *******
;  WINCE 
;   * * * * * * * * * * * * * * * * * * * * * *  IV  * * * * * * * * * * * * * * * * * * * * * * 
; **************************************Compiler specific ***************************************
; __cplusplus
; **********************************************************************************************
; ********* M A C R O S derived of C O M P I L E R   S P E C I F I C   M A C R O S  ************
; **********************************************************************************************
wci_bufp		TYPEDEF		FAR PTR hcf_8

;  segmented 16-bits or flat 32-bits pointer to 8 bits unit
wci_recordp		TYPEDEF		FAR PTR hcf_16

;  segmented 16-bits or flat 32-bits pointer to 16 bits unit
hcf_8fp		TYPEDEF		FAR PTR hcf_8

;  segmented 16-bits or flat 32-bits pointer to 8 bits unit
hcf_16fp		TYPEDEF		FAR PTR hcf_16

;  segmented 16-bits or flat 32-bits pointer to 16 bits unit
hcf_32fp		TYPEDEF		FAR PTR hcf_32

;  segmented 16-bits or flat 32-bits pointer to 8 bits unit
;   * * * * * * * * * * * * * * * * * * * * * *  V  * * * * * * * * * * * * * * * * * * * * * * 
hcf_io		TYPEDEF		hcf_16

; HCF_MEM_IO
; HCF_PORT_IO
;  MSF_COMPONENT_ID is used to define the CFG_IDENTITY_STRCT in HCF.C
;  * CFG_IDENTITY_STRCT is defined in HCF.C purely based on convenience arguments
;  * The HCF can not have the knowledge to determine the ComponentId field of the
;  * Identity record (aka as Version Record), therefore the MSF part of the Drivers
;  * must supply this value via the System Constant MSF_COMPONENT_ID
;  * There is a set of values predefined in MDD.H (format COMP_ID_.....)
;  
; **********************************************************************************************
; **************  E N V I R O N M E N T   S P E C I F I C   M A C R O S  ***********************
; **********************************************************************************************
; the next line may need modification for a specific environment
; **********************************************************************************************
; *****  M S F    S U P P O R T    F U N C T I O N S    P R O T O T Y P E S   ******************
; **********************************************************************************************
@proto_hcf94		TYPEDEF		PROTO C :wci_bufp, :WORD, :hcf_16, :SWORD
msf_assert		PROTO		@proto_hcf94

;  To increase portability, use unsigned char and unsigned char * when accessing parts of larger
;  * types to convert their Endianess
;  
;  No endianess conversion needed
;  HCF_BIG_ENDIAN
;  HCF_LITTLE_ENDIAN
;  conversion macros which can be expressed in other macros
; HCFCFG_H
; ******************************************* A L I G N M E N T  **********************************************
; default to no alignment
HCF_ALIGN		EQU		0t
;  HCF_ALIGN  
;   * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;  *	
;  *	The routines ips and ops (short for InPutString and OutPutString) are created to use the 
;  *	compiler to do the type checking. It turned out that it is too easy to accidentally pass
;  *	a word pointer to the the macros IN_PORT_STRING and OUT_PORT_STRING rather than a byte pointer.
;  *	The "+2" as some macro implementations use, does not have the intended effect in those cases.
;  *	The HCF_STRICT business can be ignored by MSF programmers.
;  *	
;  *  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
;  WaveLAN Pakket Size										
HCF_MAX_MSG		EQU		1514t
;  maximum size in bytes of "real" data in Notify command
HCF_MAX_NOTIFY		EQU		6t
; End of file hcfcfg.h
; do not move to hcf.cpp to keep Chris (Borland) and Marc (MSVC 4)happy (defines NULL)
; Begin of file c:\msvc\include\stddef.h
; **
; *stddef.h - definitions/declarations for common constants, types, variables
; *
; *   Copyright (c) 1985-1992, Microsoft Corporation.  All rights reserved.
; *
; *Purpose:
; *   This file contains definitions and declarations for some commonly
; *   used constants, types, and variables.
; *   [ANSI]
; *
; ***
;  define the NULL pointer value and the offsetof() macro 
;  offset of field m in a struct s 
;  errno declaration 
EXTERNDEF		C errno:SWORD

;  define the implementation dependent size types 
ptrdiff_t		TYPEDEF		SWORD

wchar_t		TYPEDEF		WORD

; End of file c:\msvc\include\stddef.h
;  Include file common for HCF, MSF, UIL, USF
; Begin of file mdd.h
;  This file is part of the Hardware Control Functions Light (HCF-light) library
;    to control the Lucent Technologies WaveLAN/IEEE Network I/F Card.
;    The HCF is the implementation of the Wireless Connection I/F (WCI).
;    
;    The HCF-light files are a subset of the HCF files. The complete set offers a
;    number of additional facilities, e.g. firmware download, Etherner-II encapsulation,
;    additional diagnostic facilities, ASSERT logic to support debugging, 802.11 support,
;    Configuration Management.
;    This complete set is explicitely not in the Public Domain but can be made 
;    available under certain restriction. (see the pointer below for support)
;    
;    The HCF-light files are free software; you can redistribute it and/or modify it
;    under the terms of the GNU General Public License as published by the
;    Free Software Foundation; either version 2 of the License, or (at your
;    option) any later version.
; 
;    This program is distributed in the hope that it will be useful, but
;    WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;    General Public License for more details.
; 
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software Foundation,
;    Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
;    
;    At the time of this writing, you can request for support at:
;    betasupport@wavelan.com
;    
;    Documentation is expected to be available in the week of 8 Februari 1999
; 
; 
MDD_H		EQU		1t
; ************************************************************************************************************
; *
; * FILE	 : mdd.h
; *
; * DATE   : $Date:   02 Feb 1999 14:32:36  $   $Revision:   1.0  $
; *
; * AUTHOR : Nico Valster
; *
; * DESC   : Definitions and Prototypes for HCF, MSF, UIL as well as USF sources
; *
; *
; *
; * Implementation Notes
; *
;  -	Typ rather than type is used as field names in structures like CFG_CIS_STRCT because type leads to
;  	conflicts with MASM when the H-file is converted to an INC-file
; *
; **************************************************************************************************************
; Instructions to convert MDD.H to MDD.INC by means of H2INC
; 
; Use a command line which defines the specific macros and command line options
; needed to build the C-part, e.g. for the DOS ODI driver
; 		`h2inc /C /Ni /Zp /Zn mdd	 mdd.h`
; 
; 
; **************************************************************************************************************
; * COPYRIGHT (c) 1998 by Lucent Technologies.	 All Rights Reserved.
; ************************************************************************************************************
; ***************************************************************************
; $Log$
; Revision 1.3  1999/02/01 22:58:35  nico
; *** empty log message ***
; 
; Revision 1.2  1999/02/01 21:01:41  nico
; *** empty log message ***
; 
; Revision 1.1  1999/01/30 19:24:39  nico
; Initial revision
; 
; Revision 1.1  1999/01/30 19:07:57  nico
; Initial revision
; 
;  * 
;  *    Rev 1.110   29 Jan 1999 15:52:44   NVALST
;  * intermediate, maybe working but seems to need two times to load in 
;  * light-version
;  * 
;  *    Rev 2.12   29 Jan 1999 10:48:46   NVALST
;  * 
;  *    Rev 1.108   28 Jan 1999 14:43:24   NVALST
;  * intermediate, once more correction of loop in hcf_service_nic + download
;  * passed to Marc
;  * 
;  *    Rev 2.11   27 Jan 1999 16:57:42   NVALST
;  * 
;  *    Rev 1.107   27 Jan 1999 13:53:24   NVALST
;  * intermediate, once more correction of loop in hcf_service_nic
;  * 
;  *    Rev 1.106   26 Jan 1999 16:42:46   NVALST
;  * intermediate, corrected loop in hcf_service_nic (which was as result of a 
;  * walkthrough, changed from a bug without consequences into one with consequences
;  * 
;  *    Rev 1.105   25 Jan 1999 14:24:48   NVALST
;  * intermediate, hopefully suitable for release
;  * 
;  *    Rev 1.104   22 Jan 1999 16:59:34   NVALST
;  * intermediate, minor corrections + some HCF-L stuff
;  * 
;  *    Rev 1.103   15 Jan 1999 15:14:46   NVALST
;  * intermediate, deposited as HCF2.10
;  * 
;  *    Rev 2.10   15 Jan 1999 14:54:36   NVALST
;  * 
;  *
; ***************************************************************************
; ***************************************************************************
; *
; * CHANGE HISTORY
; *
;   961018 - NV
; 	Original Entry, split of from HCF.H
; 
; ************************************************************************************************************
; *****************************      M A C R O S     *******************************************************
;  min and max macros 
; ***********************************************************************************************************
; ***************************** General define **************************************************************
MAC_ADDR_SIZE		EQU		6t
STAT_NAME_SIZE		EQU		32t
; IFB field related
; 		IFB_CardStat
;  MSF defines card as being present
; 												 * controls whether hcf-function is allowed to do I/O		
CARD_STAT_PRESENT		EQU		000008000h
;  one or more MAC Ports enabled
CARD_STAT_ENABLED		EQU		000004000h
;  Hermes Initiliazed
CARD_STAT_INI		EQU		000000800h
; 		IFB_RxStat
; Error mask
RX_STAT_ERR		EQU		000000003h
; Non-decryptable encrypted message
RX_STAT_UNDECR		EQU		000000002h
; FCS error
RX_STAT_FCS_ERR		EQU		000000001h
; ***************************** Xxxxxxxx ********************************************************************
; hcf_stat
HCF_FAILURE		EQU		255t
;  An (unspecified) failure, 0xFF is choosen to have a non-ubiquitous value
; 	                                 *	Note that HCF_xxxx errors which can end up in the CFG_DIAG LTV should
; 	                                 *	never exceed 0xFF, because the high order byte of VAL[0] is reserved
; 	                                 *	for Hermes errors
; 	                                 
HCF_SUCCESS		EQU		0t
;  0x00: OK
; gap for ODI related status
HCF_ERR_DIAG_0		EQU		2t
;  0x02: HCF noticed an error after hcf_disable, before diagnose command
HCF_ERR_DIAG_1		EQU		3t
;  0x03: HCF noticed an error after succesful diagnose command
HCF_ERR_TIME_OUT		EQU		4t
;  0x04: Expected Hermes event did not occure in expected time
HCF_ERR_NO_NIC		EQU		5t
;  0x05: card not found (usually yanked away during hcfio_in_string
HCF_ERR_BUSY		EQU		6t
;  0x06: ;?Inquire cmd while another Inquire in progress
HCF_ERR_SEQ_BUG		EQU		7t
;  0x07: other cmd than the expected completed, probably HCF-bug
HCF_ERR_LEN		EQU		8t
;  0x08: buffer size insufficient
; 		  -	hcf_get_info buffer has a size of 0 or 1 or less than needed
; 			to accomodate all data

;  (ODI initiated) return status of hcf_act( HCF_ACT_INT_OFF )
HCF_INT_PENDING		EQU		1t
;  hard coded values (e.g. for HCF_ACT_TALLIES and HCF_ACT_INT_OFF) are needed for HCFL							
; hcf_action_cmd
; 	gap left over by swapping 3 frame mode action with 4 INT_OFF/_ON
; 										 *	CARD_IN/_OUT. This was done to have HCFL default automagically
; 										 *	to HCF_ACT_802_3_PURE
; 										 *	This gap available for future features								
HCF_ACT_SPARE_03		EQU		0t
; 03 gap available for future features
;  DUI code 0x04 -> DON'T EVER MOVE 									
;  DUI code 0x05 -> DON'T EVER MOVE 									
HCF_ACT_TALLIES		EQU		5t
; 05 Hermes Inquire Tallies (F100) command
;  HCF_ASSERT
;  DUI code 0x0B -> DON'T EVER MOVE 									
;  DUI code 0x0C -> DON'T EVER MOVE 									
HCF_ACT_INT_OFF		EQU		13t
; 0D Disable Interrupt generation
HCF_ACT_INT_ON		EQU		14t
; 0E Enable Interrupt generation
HCF_ACT_CARD_IN		EQU		15t
; 0F MSF reported Card insertion
HCF_ACT_CARD_OUT		EQU		16t
; 10 MSF reported Card removal
; 	HCF_ACT_MAX							// xxxx: start value for UIL-range, NOT to be passed to HCF
;  *										Too bad, there was originally no spare room created to use
;  *										HCF_ACT_MAX as an equivalent of HCF_ERR_MAX. Since creating
;  *										this room in retrospect would create a backward incompatibilty
;  *										we will just have to live with the haphazard sequence of
;  *										UIL- and HCF specific codes. Theoretically this could be
;  *										corrected when and if there will ever be an overall 
;  *										incompatibilty introduced for another reason
;  

hcf_action_cmd		TYPEDEF		SWORD

; ============================================================= HCF Defined RECORDS	=========================
; ============================================================= INFORMATION FRRAMES		=====================
; lowest value representing an Informatio Frame
CFG_INFO_FRAME_MIN		EQU		00000f000h
; Communications Tallies
CFG_TALLIES		EQU		00000f100h
; Scan results
CFG_SCAN		EQU		00000f101h
; Link Status
CFG_LINK_STAT		EQU		00000f200h
; ============================================================= CONFIGURATION RECORDS	=====================
; ============================================================= mask 0xFCxx				=====================
; 	NETWORK PARAMETERS, STATIC CONFIGURATION ENTITIES
; FC05, FC0A, FC0B, FC0C, FC0D: SEE W2DN149
; lowest value representing a Configuration RID
CFG_RID_CFG_MIN		EQU		00000fc00h
; [STA] Connection control characteristics
CFG_CNF_PORT_TYPE		EQU		00000fc00h
; [STA] MAC Address of this node
CFG_CNF_OWN_MAC_ADDR		EQU		00000fc01h
; [STA] Service Set identification for connection
CFG_CNF_DESIRED_SSID		EQU		00000fc02h
; Communication channel for BSS creation
CFG_CNF_OWN_CHANNEL		EQU		00000fc03h
; IBSS creation (STA) or ESS (AP) Service Set Ident
CFG_CNF_OWN_SSID		EQU		00000fc04h
; [STA] ATIM Window time for IBSS creation
CFG_CNF_OWN_ATIM_WINDOW		EQU		00000fc05h
; System Scale that specifies the AP density
CFG_CNF_SYSTEM_SCALE		EQU		00000fc06h
; Maximum length of MAC Frame Body data
CFG_CNF_MAX_DATA_LEN		EQU		00000fc07h
; [STA] MAC Address of corresponding WDS Link node
CFG_CNF_WDS_ADDR		EQU		00000fc08h
; [STA] Switch for ESS Power Management (PM) On/Off
CFG_CNF_PM_ENABLED		EQU		00000fc09h
; [STA] Switch for ESS PM EPS/PS Mode
CFG_CNF_PM_EPS		EQU		00000fc0ah
; [STA] Switch for ESS PM Multicast reception On/Off
CFG_CNF_MCAST_RX		EQU		00000fc0bh
; [STA] Maximum sleep time for ESS PM
CFG_CNF_MAX_SLEEP_DURATION		EQU		00000fc0ch
; [STA] Holdover time for ESS PM
CFG_CNF_HOLDOVER_DURATION		EQU		00000fc0dh
; Identification text for diagnostic purposes
CFG_CNF_OWN_NAME		EQU		00000fc0eh
; 	NETWORK PARAMETERS, DYNAMIC CONFIGURATION ENTITIES
; [STA] Multicast MAC Addresses for Rx-message
CFG_GROUP_ADDR		EQU		00000fc80h
; [STA] Switch for IBSS creation On/Off
CFG_CREATE_IBSS		EQU		00000fc81h
; [STA] Fragment length for unicast Tx-message
CFG_FRAGMENTATION_THRH		EQU		00000fc82h
; [STA] Frame length used for RTS/CTS handshake
CFG_RTS_THRH		EQU		00000fc83h
; [STA] Data rate control for message transmission
CFG_TX_RATE_CONTROL		EQU		00000fc84h
; [STA] Switch for Promiscuous mode reception On/Off
CFG_PROMISCUOUS_MODE		EQU		00000fc85h
; 	BEHAVIOR PARAMETERS	
; [PRI] Auxiliary Timer tick interval
CFG_TICK_TIME		EQU		00000fce0h
; highest value representing an Configuration RID
CFG_RID_CFG_MAX		EQU		00000fcffh
; ============================================================= INFORMATION RECORDS 	=====================
; ============================================================= mask 0xFDxx				=====================
; 	NIC INFORMATION	
; lowest value representing an Information RID
CFG_RID_INF_MIN		EQU		00000fd00h
CFG_PRI_IDENTITY		EQU		00000fd02h
; Primary supplier range
CFG_PRI_SUP_RANGE		EQU		00000fd03h
CFG_CFI_ACT_RANGES_PRI		EQU		00000fd04h
; H/W - S/W I/F supplier range
CFG_HSI_SUP_RANGE		EQU		00000fd09h
CFG_NIC_SERIAL_NUMBER		EQU		00000fd0ah
CFG_NIC_IDENTITY		EQU		00000fd0bh
CFG_MFI_SUP_RANGE		EQU		00000fd0ch
CFG_CFI_SUP_RANGE		EQU		00000fd0dh
; Allowed communication channels
CFG_CHANNEL_LIST		EQU		00000fd10h
; List of intended regulatory domains
CFG_REG_DOMAINS		EQU		00000fd11h
; Hardware temperature range code
CFG_TEMP_TYPE		EQU		00000fd12h
; PC Card Standard Card Information Structure
CFG_CIS		EQU		00000fd13h
CFG_STA_IDENTITY		EQU		00000fd20h
; Station supplier range
CFG_STA_SUP_RANGE		EQU		00000fd21h
CFG_MFI_ACT_RANGES_STA		EQU		00000fd22h
CFG_CFI_ACT_RANGES_STA		EQU		00000fd23h
; 	MAC INFORMATION
; [STA] Actual MAC Port connection control status
CFG_PORT_STAT		EQU		00000fd40h
; [STA] Identification of the actually connected SS
CFG_CURRENT_SSID		EQU		00000fd41h
; [STA] Identification of the actually connected BSS
CFG_CURRENT_BSSID		EQU		00000fd42h
; [STA] Quality of the Basic Service Set connection
CFG_COMMS_QUALITY		EQU		00000fd43h
; [STA] Actual transmit data rate
CFG_CURRENT_TX_RATE		EQU		00000fd44h
; Beacon transmit interval time for BSS creation
CFG_OWN_BEACON_INTERVAL		EQU		00000fd45h
; Actual System Scale thresholds settings
CFG_CUR_SCALE_THRH		EQU		00000fd46h
; Max time to await a response to a request message
CFG_PROTOCOL_RSP_TIME		EQU		00000fd47h
; Max number of transmit attempts for short frames
CFG_SHORT_RETRY_LIMIT		EQU		00000fd48h
; Max number of transmit attempts for long frames
CFG_LONG_RETRY_LIMIT		EQU		00000fd49h
; Max transmit frame handling duration
CFG_MAX_TX_LIFETIME		EQU		00000fd4ah
; Max received frame handling duration
CFG_MAX_RX_LIFETIME		EQU		00000fd4bh
; [STA] Contention Free pollable capability indication
CFG_CF_POLLABLE		EQU		00000fd4ch
; Available Authentication Algorithms indication
CFG_AUTHENTICATION_ALGORITHMS		EQU		00000fd4dh
; Available Authentication Types indication
CFG_AUTHENTICATION_TYPE		EQU		00000fd4eh
; WEP Option availability indication
CFG_PRIVACY_OPTION_IMPLEMENTED		EQU		00000fd4fh
; 	MODEM INFORMATION	
; 		// 	Physical layer type indication
CFG_PHY_TYPE		EQU		00000fdc0h
; Actual frequency channel used for transmission
CFG_CURRENT_CHANNEL		EQU		00000fdc1h
; Actual power consumption status
CFG_CURRENT_POWER_STATE		EQU		00000fdc2h
; Clear channel assessment mode indication
CFG_CCAMODE		EQU		00000fdc3h
; Clear channel assessment time
CFG_CCATIME		EQU		00000fdc4h
; MAC processing delay time
CFG_MAC_PROCESSING_DELAY		EQU		00000fdc5h
; Data rates capability information
CFG_SUPPORTED_DATA_RATES		EQU		00000fdc6h
; highest value representing an Information RID
CFG_RID_INF_MAX		EQU		00000fdffh
; } hcf_info_type;
; ***********************************************************************************************************
; ***************************** S T R U C T U R E   D E F I N I T I O N S ***********************************
; used for all "minimal" LTV records
; default length of RID
; RID identification as defined by Hermes
; do not change this, some dynamic structures are defined based on this !!
LTV_STRCT		STRUCT 1t
len		hcf_16		?
typ		hcf_16		?
val		hcf_16		1t DUP (?)
LTV_STRCT		ENDS

LTVP		TYPEDEF		FAR PTR LTV_STRCT

; Windows 9x/NT Miniport
COMP_ID_MINIPORT		EQU		41t
; Packet
COMP_ID_PACKET		EQU		42t
; DOS ODI
COMP_ID_ODI_16		EQU		43t
; 32-bits ODI
COMP_ID_ODI_32		EQU		44t
; Macintosh OS
COMP_ID_MAC_OS		EQU		45t
; Windows CE Miniport
COMP_ID_WIN_CE		EQU		46t
; You never guessed, Linux
COMP_ID_LINUX		EQU		47t
; WaveLAN/IEEE AP
COMP_ID_AP1		EQU		81t
; supplier
COMP_ROLE_SUPL		EQU		          0o
; actor
COMP_ROLE_ACT		EQU		          1o
; Modem		 		- Firmware	I/F
COMP_ID_MFI		EQU		          1o
; Controller		- Firmware	I/F
COMP_ID_CFI		EQU		          2o
; Primary Firmware	- Driver	I/F
COMP_ID_PRI		EQU		          3o
; Station Firmware	- Driver	I/F
COMP_ID_STA		EQU		          4o
; Driver			- Utility	I/F
COMP_ID_DUI		EQU		          5o
; H/W               - Driver	I/F
COMP_ID_HSI		EQU		          6o
; CFG_REG_DOMAINS (0xFD11) List of intended regulatory domains.
; length of RID
; RID identification as defined by Hermes
CFG_REG_DOMAINS_STRCT		STRUCT 1t
len		hcf_16		?
typ		hcf_16		?
domains		hcf_16		6t DUP (?)
CFG_REG_DOMAINS_STRCT		ENDS

; CFG_CIS (0xFD13) PC Card Standard Card Information Structure
; length of RID
; RID identification as defined by Hermes
; Compact CIS Area, a linked list of tuples
CFG_CIS_STRCT		STRUCT 1t
len		hcf_16		?
typ		hcf_16		?
cis		hcf_16		240t DUP (?)
CFG_CIS_STRCT		ENDS

; CFG_COMMS_QUALITY (0xFD43) Quality of the Basic Service Set connection [STA]
; length of RID
; RID identification as defined by Hermes
; Communication Quality of the BSS the station is connected to
; Average Signal Level of the BSS the station is connected to
; Average Noise Level of the currently used Frequency Channel
CFG_COMMS_QUALITY_STRCT		STRUCT 1t
len		hcf_16		?
typ		hcf_16		?
coms_qual		hcf_16		?
signal_lvl		hcf_16		?
noise_lvl		hcf_16		?
CFG_COMMS_QUALITY_STRCT		ENDS

; CFG_CUR_SCALE_THRH (0xFD46) Actual System Scale thresholds
; default length of RID [STA: 6  AP: 4]
; RID identification as defined by Hermes
; Receiver H/W Energy Detect Threshold
; Receiver H/W Carrier Detect Threshold
; Receiver H/W Defer Threshold
; Firmware Roaming Cell Search Threshold [STA]
; Firmware Roaming Out of Range Threshold [STA]
; Firmware Roaming Delta SNR value [STA]
CFG_CUR_SCALE_THRH_STRCT		STRUCT 1t
len		hcf_16		?
typ		hcf_16		?
energy_detect_thrh		hcf_16		?
carrier_detect_thrh		hcf_16		?
defer_thrh		hcf_16		?
cell_search_thrh		hcf_16		?
out_of_range_thrh		hcf_16		?
delta_snr		hcf_16		?
CFG_CUR_SCALE_THRH_STRCT		ENDS

; CFG_PCF_INFO (0xFD87) Point Coordination Function capability info [AP]
; default length of RID
; RID identification as defined by Hermes
CFG_PCF_INFO_STRCT		STRUCT 1t
len		hcf_16		?
typ		hcf_16		?
energy_detect_thrh		hcf_16		?
carrier_detect_thrh		hcf_16		?
defer_thrh		hcf_16		?
cell_search_thrh		hcf_16		?
range_thrh		hcf_16		?
CFG_PCF_INFO_STRCT		ENDS

; 0xFC01	[STA] MAC Address of this node.
; 0xFC08	STA] MAC Address of corresponding WDS Link node.
; 0xFC11	[AP] Port 1 MAC Adrs of corresponding WDS Link node
; 0xFC12	[AP] Port 2 MAC Adrs of corresponding WDS Link node
; 0xFC13	[AP] Port 3 MAC Adrs of corresponding WDS Link node
; 0xFC14	[AP] Port 4 MAC Adrs of corresponding WDS Link node
; 0xFC15	[AP] Port 5 MAC Adrs of corresponding WDS Link node
; 0xFC16	[AP] Port 6 MAC Adrs of corresponding WDS Link node
; default length of RID
; RID identification as defined by Hermes
CFG_MAC_ADDR_STRCT		STRUCT 1t
len		hcf_16		?
typ		hcf_16		?
mac_addr		hcf_16		3t DUP (?)
CFG_MAC_ADDR_STRCT		ENDS

; 0xFC02	[STA] Service Set identification for connection.
; 0xFC04	IBSS creation (STA) or ESS (AP) Service Set Ident
; 0xFC0E	Identification text for diagnostic purposes.
; default length of RID
; RID identification as defined by Hermes
CFG_ID_STRCT		STRUCT 1t
len		hcf_16		?
typ		hcf_16		?
id		hcf_16		17t DUP (?)
CFG_ID_STRCT		ENDS

DUIP		TYPEDEF		PTR 

;  MDD_H
; End of file mdd.h
; **********************************************************************************************************
; *****************   H C F  F U N C T I O N   P A R A M E T E R	 ***************************************
; **********************************************************************************************************
; offsets for hcf_put_data and hcf_get_data
;  802.3/E-II/802.11 offsets to access Hermes control fields
; 0x0000
HFS_STAT		EQU		0ffffffd2h
; link "natural" HCF name to "natural" MSF name
HFS_STAT_ERR		EQU		000000003h
; 0x0006
HFS_Q_INFO		EQU		0ffffffd8h
; 0x000C
HFS_TX_CNTL		EQU		0ffffffdeh
; 0x000E
HFS_FRAME_CNTL		EQU		0ffffffe0h
; 0x0010
HFS_ID		EQU		0ffffffe2h
;  802.11 relative offsets to access 802.11 header fields 
; 0x0012
HFS_ADDR_1		EQU		000000000h
; 0x0018
HFS_ADDR_2		EQU		000000006h
; 0x001E
HFS_ADDR_3		EQU		00000000ch
; 0x0024
HFS_SEQ_CNTL		EQU		000000012h
; 0x0026
HFS_ADDR_4		EQU		000000014h
; 0x002C
HFS_DAT_LEN		EQU		00000001ah
;  802.3 / E-II relative offsets to access 802.3 header fields
; 0x002E
HFS_ADDR_DEST		EQU		000000000h
; 0x0034
HFS_ADDR_SRC		EQU		000000006h
; 0x003A
HFS_LEN		EQU		00000000ch
; 0x003C
HFS_DAT		EQU		00000000eh
;  E-II relative offsets to access SNAP header fields
; 0x0042	//Eternet-II type in 1042/Bridge-Tunnel encapsulated frame
HFS_TYPE		EQU		000000014h
; #define HCF_ACT_INT_PENDING	0x0001		//interrupt pending, return status HCF_ACT_INT_OFF
; ***********************************************************************************************************
; ***************   H C F  F U N C T I O N   R E T U R N   C O D E S   **************************************
; ***********************************************************************************************************
; Debug Purposes only				!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; WMAC Controller Auxiliary Timer Tick
HREG_EV_TICK		EQU		000008000h
; WMAC Controller H/W error (Wait Time-out)
HREG_EV_RES		EQU		000004000h
; WMAC did not have sufficient RAM to build Unsollicited Frame
HREG_EV_INFO_DROP		EQU		000002000h
;  PSEUDO event: card removed											  
HREG_EV_NO_CARD		EQU		000000800h
;  PSEUDO event: WMP frame received										  
HREG_EV_DUIF_RX		EQU		000000400h
; WMAC Controller Asynchronous Information Frame
HREG_EV_INFO		EQU		000000080h
; WMAC Controller Command completed, Status and Response avaialble
HREG_EV_CMD		EQU		000000010h
; WMAC Controller Asynchronous part of Allocation/Reclaim completed
HREG_EV_ALLOC		EQU		000000008h
; WMAC Controller Asynchronous Transmission unsuccessful completed
HREG_EV_TX_EXC		EQU		000000004h
; WMAC Controller Asynchronous Transmission successful completed
HREG_EV_TX		EQU		000000002h
; WMAC Controller Asynchronous Receive Frame
HREG_EV_RX		EQU		000000001h
; =========================================  T A L L I E S  ===================================================
; Hermes Tallies (IFB substructure)
CFG_HERMES_TALLIES_STRCT		STRUCT 1t
TxUnicastFrames		hcf_32		?
TxMulticastFrames		hcf_32		?
TxFragments		hcf_32		?
TxUnicastOctets		hcf_32		?
TxMulticastOctets		hcf_32		?
TxDeferredTransmissions		hcf_32		?
TxSingleRetryFrames		hcf_32		?
TxMultipleRetryFrames		hcf_32		?
TxRetryLimitExceeded		hcf_32		?
TxDiscards		hcf_32		?
RxUnicastFrames		hcf_32		?
RxMulticastFrames		hcf_32		?
RxFragments		hcf_32		?
RxUnicastOctets		hcf_32		?
RxMulticastOctets		hcf_32		?
RxFCSErrors		hcf_32		?
RxDiscards_NoBuffer		hcf_32		?
TxDiscardsWrongSA		hcf_32		?
RxWEPUndecryptable		hcf_32		?
RxMsgInMsgFragments		hcf_32		?
RxMsgInBadMsgFragments		hcf_32		?
CFG_HERMES_TALLIES_STRCT		ENDS

; Note this way to define CFG_TALLIES_STRCT_SIZE implies that all tallies must keep the same (hcf_32) size
; **********************************************************************************************************
; **********   W C I    F U N C T I O N S    P R O T O T Y P E S   *****************************************
; **********************************************************************************************************
;  initially 80, to be incremented by every IFB layout change		
IFB_VERSION		EQU		000000082h
;  identifier IFB_STRCT on typedef line needed to get the individual fields in the MS Browser DataBase	
; I/F Block
;  MSF readable part of Result block structure							************************************
;  I/O address of Hermes chip as passed by MSF at hcf_connect call	
;  Optional field, makes IFB-layout independent of IFB_IOBase size
; HCF_PORT_IO
;  I/O Range used by Hermes chip
;  initially 0, to be incremented by every IFB layout change		
;  align/slack space												
;  Major version of the HCF.0x01 for this release
;  Minor version of the HCF.  Incremented for each coding maintenance 
;   										 * cycle. 0x01 for the Initial release								
; Hermes tallies
;  part I (survives hcf_disable)    ***********************************************************************
;  see Design spec													
;  frame type dependent offset (HFS_ADDR_1_ABS or HFS_ADDR_DEST_ABS)
;  frame type dependent gap fence (HFS_ADDR_DEST_ABS or HFS_LEN_ABS)
;  see Design spec													
;  initialization of counter for 1 ms processor loop				
;  keep this unsigned otherwise the "clever" ASSERT in hcf_disable 
;   										 * has a higher risk to get into trouble on slow machines
;   										 * keep this hcf_16 to prevent a "close to infinity" time out if
;   										 * calibration fails on 32-bits machine								
;  see Design spec													
;  align/slack space												
;  part II (cleared or re-initialized at hcf_disable/hcf_enable)   ****************************************
;  see Design spec   //;?Q:int better than hcf_8 A: No!				
;  Value indicating the command resource availability for the 
;   										 * Driver-Utility I/F (i.e. hcf_send_diag_msg).						
;  Values: 
;  * No command resource		0									
;  * Command resource available	01h-FFh								
;  see Design spec   //;?Q:int better than hcf_8 A: No!				
;  align/slack space												
;  see Design spec													
;  field which contains FID value identifying the Tx Frame Structure,
;   										 * to be used by hcf_send_diag_msg									
;  field which contains FID value identifying the Notify Frame Struct
;   										 * to be used by hcf_put_info in case of Notify type codes			
;  see Design spec													
;  pass appropriate FID to hcf_put_mb_info							
;  see Design spec													
;  see Design spec													
;  see Design spec													
;  see Design spec													
;  see Design spec													
;  contents of HFS_TX_CNTL field of TFS
;   										 * 0: MACPort, 1: StrucType,TxEx,TxOK								
;  offset
;   										 * RID/FID															
;  offset
;   										 * RID/FID															
;  see Design spec													
;  BAP initialization or Cmd Completion failed once					
IFB_STRCT		STRUCT 1t
IFB_IOBase		hcf_io		?
IFB_IOBase_pad		hcf_16		?
IFB_IORange		hcf_16		?
IFB_Version		hcf_8		?
IFB_Slack_2		hcf_8		?
IFB_HCFVersionMajor		hcf_8		?
IFB_HCFVersionMinor		hcf_8		?
IFB_NIC_Tallies		CFG_HERMES_TALLIES_STRCT		<>
IFB_CardStat		hcf_16		?
IFB_FSBase		hcf_16		?
IFB_RxFence		hcf_16		?
IFB_IntOffCnt		hcf_16		?
IFB_TickIni		hcf_32		?
IFB_Magic		hcf_16		?
IFB_Slack_4		hcf_16		2t DUP (?)
IFB_PIFRscInd		hcf_8		?
IFB_DUIFRscInd		hcf_8		?
IFB_NotifyRscInd		hcf_8		?
IFB_Slack_6		hcf_8		?
IFB_PIF_FID		hcf_16		?
IFB_DUIF_FID		hcf_16		?
IFB_Notify_FID		hcf_16		?
IFB_RxFID		hcf_16		?
IFB_MB_FID		hcf_16		?
IFB_TxFrameType		hcf_16		?
IFB_RxLen		hcf_16		?
IFB_RxStat		hcf_16		?
IFB_UnloadIdx		hcf_16		?
IFB_PIFLoadIdx		hcf_16		?
IFB_TxCntl		hcf_8		2t DUP (?)
IFB_BAP_0		hcf_16		2t DUP (?)
IFB_BAP_1		hcf_16		2t DUP (?)
IFB_IntEnMask		hcf_16		?
IFB_TimStat		hcf_16		?
IFB_STRCT		ENDS

IFBP		TYPEDEF		PTR IFB_STRCT

@proto_hcf95		TYPEDEF		PROTO C :IFBP, :hcf_action_cmd
hcf_action		PROTO		@proto_hcf95

@proto_hcf96		TYPEDEF		PROTO C :IFBP, :wci_bufp, :WORD, :SWORD
hcf_assert		PROTO		@proto_hcf96

@proto_hcf97		TYPEDEF		PROTO C :IFBP, :hcf_io
hcf_connect		PROTO		@proto_hcf97

@proto_hcf98		TYPEDEF		PROTO C :IFBP, :hcf_16
hcf_disable		PROTO		@proto_hcf98

@proto_hcf99		TYPEDEF		PROTO C :IFBP
hcf_disconnect		PROTO		@proto_hcf99

@proto_hcf100		TYPEDEF		PROTO C :IFBP, :hcf_16
hcf_enable		PROTO		@proto_hcf100

@proto_hcf101		TYPEDEF		PROTO C :IFBP, :LTVP
hcf_get_info		PROTO		@proto_hcf101

@proto_hcf102		TYPEDEF		PROTO C :IFBP, :SWORD, :wci_bufp, :SWORD
hcf_get_data		PROTO		@proto_hcf102

@proto_hcf103		TYPEDEF		PROTO C :IFBP
hcf_service_nic		PROTO		@proto_hcf103

; EXTERN_C void	hcf_put_data		(IFBP ifbp, wci_bufp bufp, int len );
@proto_hcf104		TYPEDEF		PROTO C :IFBP, :wci_bufp, :SWORD, :hcf_16
hcf_put_data		PROTO		@proto_hcf104

@proto_hcf105		TYPEDEF		PROTO C :IFBP, :LTVP
hcf_put_info		PROTO		@proto_hcf105

@proto_hcf106		TYPEDEF		PROTO C :IFBP, :SWORD, :wci_bufp, :SWORD, :hcf_8
hcf_put_header		PROTO		@proto_hcf106

@proto_hcf107		TYPEDEF		PROTO C :IFBP, :hcf_16
hcf_send		PROTO		@proto_hcf107

@proto_hcf108		TYPEDEF		PROTO C :IFBP, :hcf_16, :wci_bufp, :SWORD
hcf_send_diag_msg		PROTO		@proto_hcf108

;  HCF_H 
; End of file hcf.h
